(load "functions.lsp")

(defun make-instanse (class-name)
    (let ((class) (ins))
	(setq class (eval class-name))
	(setq ins (make-hash-table))
	(loop
	    (if (null class) (return ins))
	    (setf (gethash (car (car class)) ins) (cdr (car class)))
	    (setq class (cdr class)) ) ) )

(defun tell (obj meth &rest args) (apply (gethash meth obj) (cons obj args)) )

(defmacro defclass (class-name)
    `(setq ,class-name nil) )

(defmacro defmethod (meth-name xxxx &rest b)
    (let ((one))
	(setq one `(,meth-name lambda ,(cons (car (car xxxx)) (cdr xxxx)) ,@b))
	`(setq ,(car (cdr (car xxxx))) (cons ',one ,(car (cdr (car xxxx)))) ) ) )
